/********************************************************************************************************
 * @file     gatt.h
 *
 * @brief    for TLSR chips
 *
 * @author	 BLE Group
 * @date     Aug. 22, 2019
 *
 * @par      Copyright (c) Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *
 *			 The information contained herein is confidential and proprietary property of Telink
 * 		     Semiconductor (Shanghai) Co., Ltd. and is available under the terms
 *			 of Commercial License Agreement between Telink Semiconductor (Shanghai)
 *			 Co., Ltd. and the licensee in separate contract or the terms described here-in.
 *           This heading MUST NOT be removed from this file.
 *
 * 			 Licensees are granted free, non-transferable use of the information in this
 *			 file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided.
 *
 *******************************************************************************************************/

#ifndef GATT_H_
#define GATT_H_


/******************************* Stack Interface Begin, user can not use!!! ********************************************/
u8		blc_gatt_requestServiceAccess(u16 connHandle, int gatt_perm);
u8 		blt_gatt_requestServiceAccess(u16 connHandle, int gatt_perm);

/******************************* Stack Interface End *******************************************************************/







/******************************* User Interface  Begin *****************************************************************/

typedef int (*gatt_handler_t) (u16 conn, u8 * p);
void 	blc_gatt_register_data_handler(gatt_handler_t handler);


ble_sts_t	blc_gatt_pushHandleValueNotify  (u16 connHandle, u16 attHandle, u8 *p, int len);
ble_sts_t	blc_gatt_pushHandleValueIndicate(u16 connHandle, u16 attHandle, u8 *p, int len);
ble_sts_t 	blc_gatt_pushWriteCommand (u16 connHandle, u16 attHandle, u8 *p, int len);
ble_sts_t 	blc_gatt_pushWriteRequest (u16 connHandle, u16 attHandle, u8 *p, int len);


//Gaoqiu
ble_sts_t 	blc_gatt_pushFindInformationRequest(u16 connHandle, u16 start_attHandle, u16 end_attHandle);
ble_sts_t   blc_gatt_pushFindByTypeValueRequest(u16 connHandle, u16 start_attHandle, u16 end_attHandle,
		                                        u16 uuid, u8 *attr_value, int len);
ble_sts_t   blc_gatt_pushReadByTypeRequest(u16 connHandle, u16 start_attHandle, u16 end_attHandle, u8 *uuid, int uuid_len);
ble_sts_t   blc_gatt_pushReadRequest(u16 connHandle, u16 attHandle);
ble_sts_t   blc_gatt_pushReadBlobRequest(u16 connHandle, u16 attHandle, u16 offset);
ble_sts_t 	blc_gatt_pushReadByGroupTypeRequest(u16 connHandle, u16 start_attHandle, u16 end_attHandle,
		                                        u8 *uuid, int uuid_len);

/******************************* User Interface  End  ******************************************************************/




#endif /* GATT_H_ */
