/********************************************************************************************************
 * @file     app.c
 *
 * @brief    for TLSR chips
 *
 * @author	 BLE Group
 * @date     May. 22, 2019
 *
 * @par      Copyright (c) Telink Semiconductor (Shanghai) Co., Ltd.
 *           All rights reserved.
 *
 *			 The information contained herein is confidential and proprietary property of Telink
 * 		     Semiconductor (Shanghai) Co., Ltd. and is available under the terms
 *			 of Commercial License Agreement between Telink Semiconductor (Shanghai)
 *			 Co., Ltd. and the licensee in separate contract or the terms described here-in.
 *           This heading MUST NOT be removed from this file.
 *
 * 			 Licensees are granted free, non-transferable use of the information in this
 *			 file under Mutual Non-Disclosure Agreement. NO WARRENTY of ANY KIND is provided.
 *
 *******************************************************************************************************/

#include "tl_common.h"
#include "drivers.h"
#include "stack/ble/ble.h"
#include "vendor/common/blt_common.h"


#include "app.h"

#include "app_att.h"
#include "app_device.h"









void user_init(void)
{

#if (   FEATURE_TEST_MODE == TEST_LL_MD)

	feature_md_test_init();

#elif (FEATURE_TEST_MODE == TEST_LL_DLE)

	feature_dle_test_init();

#elif (FEATURE_TEST_MODE == TEST_WHITELIST)

	feature_whitelist_test_init();
#elif (FEATURE_TEST_MODE == TEST_2M_PHY)

	feature_2m_phy_test_init();
#elif (FEATURE_TEST_MODE == TEST_MULTI_LOCAL_MAC)
	feature_multiLocalMAC_test_init();

#elif (FEATURE_TEST_MODE == TEST_SMP_SECURITY)
	feature_security_test_init();

#elif (FEATURE_TEST_MODE == TEST_L2CAP_CONN_PARAM_UPDATE)
	feature_l2cap_conn_param_update_test_init();
#elif(FEATURE_TEST_MODE == TEST_CSA2)
	feature_csa2_test_init();

#elif(FEATURE_TEST_MODE == TEST_GATT_API)
	feature_gatt_api_test_init();
#else

#endif

}




void main_loop (void)
{


	////////////////////////////////////// BLE entry /////////////////////////////////
	blt_llms_sdk_main_loop();



#if (   FEATURE_TEST_MODE == TEST_LL_MD)

	feature_md_test_mainloop();

#elif (FEATURE_TEST_MODE == TEST_LL_DLE)

	feature_dle_test_mainloop();

#elif (FEATURE_TEST_MODE == TEST_WHITELIST)

	feature_whitelist_test_mainloop();

#elif (FEATURE_TEST_MODE == TEST_2M_PHY)

	feature_2m_phy_test_mainloop();

#elif (FEATURE_TEST_MODE == TEST_SMP_SECURITY)
	feature_security_test_mainloop();

#elif(FEATURE_TEST_MODE == TEST_GATT_API)
	feature_gatt_api_test_mainloop();

#elif (FEATURE_TEST_MODE == TEST_L2CAP_CONN_PARAM_UPDATE)
	feature_l2cap_conn_param_update_test_mainloop();

#else

#endif
}




